<?php
/**
 * @file
 * Contains \FlagFeaturesBuilder class.
 */

class FlagFeaturesBuilder extends EntityFeaturesBuilder {

  /**
   * {@inheritdoc}
   */
  public function package() {
    return "Flags";
  }

  /**
   * List components included for a named Features module.
   */
  protected function setComponents() {
    $flag_name = substr($this->name, 5);
    $flag = flag_get_flag($flag_name);

    // Select flag feature component.
    $this->setNamedComponents('flag', array($flag->name));

    // Add field instances.
    $this->setFields('flagging', $flag->name);

    // Add flag dependency.
    $this->setNamedComponents('dependencies', array('flag'));
  }

  /**
   * List Features type modules generated by this class.
   */
  static public function listFeatures() {
    $features = array();

    // Provides a feature module for each flag.
    foreach (features_builder_get_exportables('flag') as $name => $label) {
      if (flag_get_flag($name)) {
        $features["flag_$name"] = $label;
      }
    }
    return $features;
  }
}
