<?php

/**
 * @file
 * Contains \Profile2FeaturesBuilder class.
 */

class Profile2FeaturesBuilder extends EntityFeaturesBuilder {

  protected static $profile2TypeId = 'profile2_type';

  /**
   * {@inheritdoc}
   */
  public function package() {
    return "Profiles";
  }

  /**
   * List components included for a named Features module.
   */
  protected function setComponents() {
    $entity_type = profile2_type_load(substr($this->name, (strlen($this::$profile2TypeId) + 1)));

    // Add profile2 type.
    $this->setNamedComponents($this::$profile2TypeId, array($entity_type->type));

    // Add field instances.
    $this->setFields('profile2', $entity_type->type);

    // Add profile2 dependency.
    $this->setNamedComponents('dependencies', array('profile2'));
  }

  /**
   * List Features type modules generated by this class.
   */
  public static function listFeatures() {
    $features = array();

    // Provides a Feature module for each profile2 type.
    $entity_type_id = Profile2FeaturesBuilder::$profile2TypeId;
    foreach (features_builder_get_exportables($entity_type_id) as $type => $label) {
      $features["{$entity_type_id}_$type"] = $label;
    }

    return $features;
  }
}
